/**
 * Par défaut, les instances de classes (les types non primitifs) ne sont pas
 * copiées par l'opérateur =. Pour effectuer une copie, il faut que la classe
 * implémente l'interface Cloneable définisse la méthode clone().
 */

class Test1 implements Cloneable {

    public int i;

    public String toString() {
	return Integer.toString(i);
    }

    public Test1 clone() {
	Test1 t1 = null;
	try {
	    t1 = (Test1)super.clone();
	}
	catch(CloneNotSupportedException e) {
	    
	}
	return t1;
    }

    public static void main(String[] args) {

	Test1 t1 = new Test1();
	t1.i = 5;
	Test1 t2;
	t2 = t1.clone();
	t2.i = 3;
	
	System.out.println("t1="+t1);
	System.out.println("t2="+t2);

    }

}
